
#include "BackgroundServices.h"
#include "avr/eeprom.h"

int score;

char display_msg;	

void BackgroundServices()
{
	static uint32_t last_time;
	
	if (Has_X_MillisecondsPassed(10,&last_time))
	{
		KBD_Read();
	}
	RefreshLCDandLEDs();
}

void RefreshLCDandLEDs()
{
	switch (display_msg)
	{
		
		case DISP_REFRESH_SCORE:
			LCD_RefreshScore();
			break;
		
	
		case DISP_START_SCREEN:
			DrawStartScreen();
			break;
	
		
		case DSIP_END_SCORE:
			DrawGameScore();
			break;
		default:	
		break;
	}
	display_msg=0;
}



void LCD_RefreshScore()
{
	char txt[10];
	static int oldLength;
	int i,lnt;
	UG_FontSelect(&RFONT_8X12);
	UG_SetForecolor(C_WHITE);
	sprintf(txt,"%d",score);
	lnt=strlen(txt);
	if (lnt<oldLength)
	{
		for (i=0;i<oldLength-lnt; i++) txt[lnt+i]=' ';
		txt[lnt+i]=0;	
	}
	UG_PutString((320-(TOP_FIXED_AREA-5)),20,txt);
	oldLength=lnt;
	score++;
}

void Highscore()
{
	char txt[10];
	static int oldLength;
	int i,lnt,maxscore;
	maxscore=eeprom_read_word ( (uint16_t *) 0 );
	UG_FontSelect(&RFONT_8X12);
	UG_SetForecolor(C_WHITE);
	sprintf(txt,"%d",maxscore);
	lnt=strlen(txt);
	if (lnt<oldLength)
	{
		for (i=0;i<oldLength-lnt; i++) txt[lnt+i]=' ';
		txt[lnt+i]=0;	//termination char
	}
	UG_PutString((320-(TOP_FIXED_AREA-5)),100,txt);
	oldLength=lnt;
}
void EEPROM_ScoreReset()
{
eeprom_write_word ( (uint16_t *)0, 0 );
}

void EEPROM_HighScoreRead()
{int maxscore;
	maxscore=eeprom_read_word ( (uint16_t *) 0 );
	return maxscore;
}
void EEPROM_HighScoreWrite()
{int max;
	max=eeprom_read_word ( (uint16_t *) 0 );
	if((score-1)>max)
	{
	eeprom_write_word ( (uint16_t *)0, (score-1) );
	}
	
}








void DrawStartScreen()
{	
int i,j,l=0,x=150,y=156,o;
	UG_FillFrame(0,0,320,150,C_BLUE);
	
	UG_FontSelect(&RFONT_16X26);
	UG_SetForecolor(C_RED);
	UG_SetBackcolor(C_BLANCHED_ALMOND);
	
       
	

	UG_FontSelect(&RFONT_8X12);
	UG_SetForecolor(C_BLACK);
	UG_PutString(15,100,"Press OK to start!");
	UG_PutString(15,120,"Press ESC to reset high score!");
	UG_FillCircle(200,50,15,C_WHITE);
		UG_FillCircle(220,40,20,C_WHITE);
		UG_FillCircle(240,47,15,C_WHITE);
		 UG_PutString(50,50,"FLAPPY BRICK");
		UG_FillCircle(0,0,40,C_YELLOW);
		 
	UG_FillFrame(0,150,320,240,C_BROWN);
	
	for(j=0;j<15;j++){
		j=j*6;
		UG_FillFrame(0,150+j,320,150+j+1,C_WHITE);
		j=j/6;
	}
	
	for(i=0;i<17;i++){
	i=i*20;
	UG_FillFrame(i+l,x,i+1+l,y,C_WHITE);	
	i=i/20;
	
	
	if((i==16)&&(y<=240)){
	if(o%2==0)
	l=l+10;
	else
	l=l-10;
	x=x+6;
	y=y+6;
	i=0;
	o++;
	}
	
	}
	
		 
	
}


void DrawGameScore()
{	
	char txt[10];
	UG_FontSelect(&RFONT_16X26);
	UG_SetForecolor(C_WHITE);
	UG_PutString(20,90,"Final Score:");
	sprintf(txt,"%d",score-1);
	UG_PutString(120,120,txt);
}

