

#include <avr/io.h>
#include "LCD_Ili9341.h"
#include "systime.h"
#include "kbd.h"
#include "BackgroundServices.h"
#include "avr/wdt.h"
void Init_IO();
void Game();
int WaitForStart();
int PlayTheGame();



int main(void)
{
	Init_IO();
	LCD_Init();
	Systime_Init();
	sei();
	
    /* Replace with your application code */
    while (1)
    {
		if (HasOneMillisecondPassed())
		{
			Game();
		}
		BackgroundServices();
    }
}

void Game()
{
	static int state=0;
	int result;
   
	switch (state)
	{
		case 1:	//waiting for game start
			result = WaitForStart();
			if (result == 1) state++;
			break;
		case 2: //Play the game
			result = PlayTheGame();
			if (result == 1) state++;
			break;
		case 3: //Display the score
			result = EndOfGame();
			if (result == 1) state=0;
			break;
		default: //0 RESET
			state = 1;
			break;
	}
}

int WaitForStart()
{   
	int result=0;
	static int state=1; 
	char key;
	static uint32_t startTime;
	static int x=200,x1=100,y=220,y1=120;
		switch (state)
		{
			case 1: 
			display_msg=DISP_START_SCREEN;
			state++; // state = 2;
			startTime=GetSysTick();
			break;
			case 2:
			key=KBD_GetKey();
			if(key==BTN_ESC)
			{
				EEPROM_ScoreReset();
			}
			if(key==BTN_OK) // 
			{
				result=1;
				state=1;
				
				
				
				UG_FillFrame(0,0,320-TOP_FIXED_AREA,240-40,C_BLUE);
				UG_FillFrame(320-TOP_FIXED_AREA,0,320,240,C_TOMATO);
				UG_PutString(320-TOP_FIXED_AREA+5,200,"Jernej Ilar");
				UG_PutString(320-TOP_FIXED_AREA+5,5,"Score:");
				UG_PutString(320-TOP_FIXED_AREA+5,70,"High   score:");
				Highscore();
				
				UG_FillFrame(x,x1,y,y1,C_BROWN);

				break;
			}
		break;
		
			default: // 
			PORTE=0x01;  // napaka e je led1 on
			state=1;
			break;
		}
	return result;
}

int PlayTheGame()
{
	int result=0;
int yP;
static int state=0;

char key;

 int x=200,x1=100,y=220,y1=120;


 int l=0;
 int p=0;

static int skok=0,pozicija=0,levl,prehod;
static int xP=319-TOP_FIXED_AREA;




void steber(int rnd) {
static	int old;

if(old>rnd){
UG_FillFrame(0,220-old,50,220-rnd,C_BLUE); 	
	
UG_FillFrame(0,20+rnd,50,20+old,C_BLUE); 	
} 
old=rnd;
UG_FillFrame(0,0,50,20+rnd,C_GREEN); // zgoren
UG_FillFrame(0,220-rnd,50,240,C_GREEN);   //spoden


}


switch (state)
{

case 0:

while(1)

{   



//if (HasOneMillisecondPassed())
//{
	
	KBD_Read();

	key=KBD_GetKey();
	if(key != 0)
	{
	
	if(key==BTN_A){

		l=1;
		skok=skok+30;
		pozicija=x1-skok;
		p=0;
	}

	}


	
//printf("%d",l);
if(l>=1){
	
//////////////////////////  RISANJE GOR
if((x1>(pozicija))&(p==0)){
x1=x1-1;//gor
y1=y1-1;//gor
if((x>y)&(y>0)){
UG_FillFrame(x,x1,320-TOP_FIXED_AREA,x1+1,C_BROWN);
UG_FillFrame(0,x1,y,x1+1,C_BROWN);  //x in y nesmeta bit 0
}
if(y==0){
UG_FillFrame(x,x1,320-TOP_FIXED_AREA,x1+1,C_BROWN);}
if(x<y)
UG_FillFrame(x,x1,y,x1+1,C_BROWN);
}

//////////////////////////////// VRH
if(x1==pozicija){
p=1;
skok=0;
}
////////////////////   RISANJE ZA DOL
if((x1<240)&(p==1)){
x1=x1+1;//dol
y1=y1+1;//dol

if((x>y)&(y>0)){
		UG_FillFrame(x,y1-1,320-TOP_FIXED_AREA,y1,C_BROWN);
		UG_FillFrame(0,y1-1,y,y1,C_BROWN);  //x in y nesmeta bit 0
	}
	if(y==0){
	UG_FillFrame(x,y1-1,320-TOP_FIXED_AREA,y1,C_BROWN);}
	if(x<y)
	UG_FillFrame(x,y1-1,y,y1,C_BROWN);




if(x1==240){
if((x>y)&(y>0)){
	UG_FillFrame(x,x1-1,320-TOP_FIXED_AREA,x1,C_BLUE);
	UG_FillFrame(0,x1-1,y,x1,C_BLUE);	//////////////////////////     BRISANJE spodnje
}
UG_FillFrame(x,x1-1,y,x1,C_BLUE);
p=0;
l=0;

}
}

}
////////////////////////////////////////
if(p==0){
if((x>y)&(y>0)){	
UG_FillFrame(x,y1,320-TOP_FIXED_AREA,y1+1,C_BLUE);
UG_FillFrame(0,y1,y,y1+1,C_BLUE);	//////////////////////////     BRISANJE ZA GOR DELA
}
if(y==0)
UG_FillFrame(x,y1,320-TOP_FIXED_AREA,y1+1,C_BLUE);
if(x<y)
UG_FillFrame(x,y1,y,y1+1,C_BLUE);
}

/////////////////////////////////////////
if(p==1){
	if((x>y)&(y>0)){
		UG_FillFrame(x,x1-1,320-TOP_FIXED_AREA,x1,C_BLUE);
		UG_FillFrame(0,x1-1,y,x1,C_BLUE);	//////////////////////////     BRISANJE ZA dol
	}
	if(y==0)
	UG_FillFrame(x,x1,320-TOP_FIXED_AREA,x1-1,C_BLUE);
	if(x<y)
	UG_FillFrame(x,x1-1,y,x1,C_BLUE);
}
///////////////////////////////////
//printf("%d",l);

	 x--;
	 y--;
	xP++; //navidezna x kordinata


	if(xP==(320-TOP_FIXED_AREA))        { // dorisanje/brisanje stebra
             	 xP=0;
	           yP = rand() % 50+20; 
                prehod++;
                LCD_RefreshScore();
	             steber(yP);
				 levl=(10-((prehod/10)*2));
 }
	

	
	 if(x<0){
		 x=319-TOP_FIXED_AREA;
		
	 }
	 if(y<0){
		 y=319-TOP_FIXED_AREA;
	 }
	 
	 
	UG_FillFrame(x,x1,x+1,y1,C_BROWN);
	UG_FillFrame(y,x1,y+1,y1,C_BLUE);
	 
	
	   wdt_disable();
	   wdt_enable(WDTO_60MS);	   
	
	////////collsion
	if((y1<21)||(y1>(240-40)))
	{//result=1;
	//state=1;
	EEPROM_HighScoreWrite();
	break;
	}
	
	
	if(((x<=50)||(x<=0)||(y<=50)||(y<=0))&&(x1<=(yP+20))){ // zgoren steber
	EEPROM_HighScoreWrite();
	break;
	}
	if(((x<=50)||(x<=0)||(y<=50)||(y<=0))&&(y1>=(240-(yP+20)))){ // spoden steber
		EEPROM_HighScoreWrite();
		break;
	}
	//////////////
	
 setupScrollArea(TOP_FIXED_AREA, BOT_FIXED_AREA);	 
scroll_slow(500,levl);
}


case 1:

setupScrollArea(200,200);
scroll_slow(0,0);
result=1;
break;

}
return result;

}



void Init_IO()
{
	//DDR: 1-out, 0-in
	PORTB = 0x12;	//0-LCD_DC, 1-buzzer, 2-LCD_CS,
	DDRB = 0x2D;	//3-MOSI, 4-MISO, 5-SCK, 6,7-not implemented
	
	PORTC = 0xF0;	//0..3-analog inputs
	DDRC = 0x00;	//4-SDA(not connected), 5-SCL(not connected), 6,7-not implemented
	
	PORTD = 0xBF;	//0-Rx, 1-Tx, 2..5-buttons
	DDRD = 0xC2;	//6-LCD_BACKLIGHT, 7-LCD_RESET
	
	PORTE = 0x00;	//LEDs
	DDRE = 0xFF;
}


int EndOfGame()
{

	int result=1;
	
	
	wdt_disable();
for(int i=0; i<50;i++)
	DrawGameScore();
	wdt_enable(WDTO_60MS);
	return result;
	
}