/*
 * v7.c
 *
 * Created: 04-Apr-17 14:49:45
 * Author : maticpi
 */ 

#include <avr/io.h>
#include "LCD_Ili9341.h"
#include "systime.h"
#include "kbd.h"
#include "BackgroundServices.h"

void Init_IO();
void Game();
int WaitForStart();
int PlayTheGame();
int EndOfGame();
char GetRandomMoleNumber();

int main(void)
{
	Init_IO();
	LCD_Init();
	Systime_Init();
	sei();
	
    /* Replace with your application code */
    while (1)
    {
		if (HasOneMillisecondPassed())
		{
			Game();
		}
		BackgroundServices();
    }
}

void Game()
{
	static int state;
	int result;

	switch (state)
	{
		case 1:	//waiting for game start
			result = WaitForStart();
			if (result == 1) state++;
			break;
		case 2: //Play the game
			result = PlayTheGame();
			if (result == 1) state++;
			break;
		case 3: //Display the score
			result = EndOfGame();
			if (result == 1) state=0;
			break;
		default: //0 or unknown value: reset the game
			state = 1;
			break;
	}
}

int WaitForStart()
{
	int result=0;
	//TODO: write the program
	
	return result;
}

int PlayTheGame()
{
	int result=0;
	//get the random value
	//display the random value
	//wait for key or timeout
	//return 0 if game is still on
	//return 1 if the game is over
	return result;
}

int EndOfGame()
{
	int result=0;
	//TODO: write the program
	
	return result;
}

char GetRandomMoleNumber()
{
	char rand_mole;
	//since there is no telling when the user will actually start the game,
	//the first two bits of system time are completely random
	rand_mole = GetSysTick();
	rand_mole = (rand_mole & 0x03)+1;
	return rand_mole;
}

void Init_IO()
{
	//DDR: 1-out, 0-in
	PORTB = 0x12;	//0-LCD_DC, 1-buzzer, 2-LCD_CS,
	DDRB = 0x2D;	//3-MOSI, 4-MISO, 5-SCK, 6,7-not implemented
	
	PORTC = 0xF0;	//0..3-analog inputs
	DDRC = 0x00;	//4-SDA(not connected), 5-SCL(not connected), 6,7-not implemented
	
	PORTD = 0xBF;	//0-Rx, 1-Tx, 2..5-buttons
	DDRD = 0xC2;	//6-LCD_BACKLIGHT, 7-LCD_RESET
	
	PORTE = 0x00;	//LEDs
	DDRE = 0xFF;
}